#include "Application.hpp"
#include "GameState.hpp"
#include "PauseState.hpp"
#include "World.hpp"
#include "Eagle.hpp"

GameState::GameState(StateStack& stack, Context context) : State(stack, context), world(context) {

}


bool GameState::HandleEvent(const sf::Event& e) {
	switch(e.type) {
	case sf::Event::MouseMoved:
		//world.getPlayer().setPosition(e.mouseMove.x, e.mouseMove.y);
		break;
	case sf::Event::KeyPressed:
		if(e.key.code == sf::Keyboard::R) {
			Command cm(Category::Player, derivedAction<Entity>([](Entity& e, sf::Time) {
				e.setPosition(640, 100);
				e.velocity = sf::Vector2f();
			}));

			world.getCommandQueue().push(cm);
		}
		break;

	case sf::Event::LostFocus:
		RequestStackPush(States::PAUSESTATE);
		break;
	}
	return true;
}


bool GameState::Update(sf::Time& dt) {
	// Restart when player dead
	if(world.getPlayer().isMarkedForRemoval()) {
		lastScore = world.getPlayer().score;
		RequestStateClear();
		RequestStackPush(States::GAMEOVERSTATE);
		return false;
	}
	
	world.update(dt);

	return true;
}

void GameState::Draw(sf::RenderTarget& target, sf::RenderStates states) {
	world.draw(target, states);
}