#include "PauseState.hpp"
#include "Utility.hpp"

PauseState::PauseState(StateStack& stack, Context context)
	: State(stack, context)
	, hasFocus(false)
	, text("Press SPACE to continue", context.fonts->Get(Font::Emulator)) {

	sf::Vector2u wSize = Application::settings.windowSize;
	CenterOrigin(text);
	text.setPosition(wSize.x / 2, wSize.y / 2);
	text.setColor(sf::Color());

	bg.setSize(sf::Vector2f(wSize.x, wSize.y));
	bg.setFillColor(sf::Color(255, 255, 255, 192));
}


bool PauseState::HandleEvent(const sf::Event& e) {
	switch(e.type) {
	case sf::Event::GainedFocus:
		hasFocus = true;
		break;

	case sf::Event::LostFocus:
		hasFocus = false;
		break;

	case sf::Event::KeyPressed:
		if(e.key.code == sf::Keyboard::Space && hasFocus) {
			RequestStackPop();
		}
		break;
	}

	return false;
}

bool PauseState::Update(sf::Time& dt) {
	return false;
}

void PauseState::Draw(sf::RenderTarget& target, sf::RenderStates states) {
	target.setView(GetContext().renderWindow->getDefaultView());
	
	target.draw(bg);
	target.draw(text);
}